# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ZoneAssignmentSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'zone_id': 'str',
        'priority': 'int',
        'max_number_instances': 'int',
        'memory_limit_mb': 'int',
        'cpu_limit': 'int',
        'storage_limit_gb': 'int'
    }

    attribute_map = {
        'zone_id': 'zoneId',
        'priority': 'priority',
        'max_number_instances': 'maxNumberInstances',
        'memory_limit_mb': 'memoryLimitMB',
        'cpu_limit': 'cpuLimit',
        'storage_limit_gb': 'storageLimitGB'
    }

    def __init__(self, zone_id=None, priority=None, max_number_instances=None, memory_limit_mb=None, cpu_limit=None, storage_limit_gb=None):  # noqa: E501
        """ZoneAssignmentSpecification - a model defined in Swagger"""  # noqa: E501
        self._zone_id = None
        self._priority = None
        self._max_number_instances = None
        self._memory_limit_mb = None
        self._cpu_limit = None
        self._storage_limit_gb = None
        self.discriminator = None
        if zone_id is not None:
            self.zone_id = zone_id
        if priority is not None:
            self.priority = priority
        if max_number_instances is not None:
            self.max_number_instances = max_number_instances
        if memory_limit_mb is not None:
            self.memory_limit_mb = memory_limit_mb
        if cpu_limit is not None:
            self.cpu_limit = cpu_limit
        if storage_limit_gb is not None:
            self.storage_limit_gb = storage_limit_gb

    @property
    def zone_id(self):
        """Gets the zone_id of this ZoneAssignmentSpecification.  # noqa: E501

        The Cloud Zone Id  # noqa: E501

        :return: The zone_id of this ZoneAssignmentSpecification.  # noqa: E501
        :rtype: str
        """
        return self._zone_id

    @zone_id.setter
    def zone_id(self, zone_id):
        """Sets the zone_id of this ZoneAssignmentSpecification.

        The Cloud Zone Id  # noqa: E501

        :param zone_id: The zone_id of this ZoneAssignmentSpecification.  # noqa: E501
        :type: str
        """

        self._zone_id = zone_id

    @property
    def priority(self):
        """Gets the priority of this ZoneAssignmentSpecification.  # noqa: E501

        The priority of this zone in the current project. Lower numbers mean higher priority. Default is 0 (highest)  # noqa: E501

        :return: The priority of this ZoneAssignmentSpecification.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this ZoneAssignmentSpecification.

        The priority of this zone in the current project. Lower numbers mean higher priority. Default is 0 (highest)  # noqa: E501

        :param priority: The priority of this ZoneAssignmentSpecification.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def max_number_instances(self):
        """Gets the max_number_instances of this ZoneAssignmentSpecification.  # noqa: E501

        The maximum number of instances that can be provisioned in this cloud zone. Default is 0 (unlimited instances).  # noqa: E501

        :return: The max_number_instances of this ZoneAssignmentSpecification.  # noqa: E501
        :rtype: int
        """
        return self._max_number_instances

    @max_number_instances.setter
    def max_number_instances(self, max_number_instances):
        """Sets the max_number_instances of this ZoneAssignmentSpecification.

        The maximum number of instances that can be provisioned in this cloud zone. Default is 0 (unlimited instances).  # noqa: E501

        :param max_number_instances: The max_number_instances of this ZoneAssignmentSpecification.  # noqa: E501
        :type: int
        """

        self._max_number_instances = max_number_instances

    @property
    def memory_limit_mb(self):
        """Gets the memory_limit_mb of this ZoneAssignmentSpecification.  # noqa: E501

        The maximum amount of memory that can be used by this cloud zone. Default is 0 (unlimited memory).  # noqa: E501

        :return: The memory_limit_mb of this ZoneAssignmentSpecification.  # noqa: E501
        :rtype: int
        """
        return self._memory_limit_mb

    @memory_limit_mb.setter
    def memory_limit_mb(self, memory_limit_mb):
        """Sets the memory_limit_mb of this ZoneAssignmentSpecification.

        The maximum amount of memory that can be used by this cloud zone. Default is 0 (unlimited memory).  # noqa: E501

        :param memory_limit_mb: The memory_limit_mb of this ZoneAssignmentSpecification.  # noqa: E501
        :type: int
        """

        self._memory_limit_mb = memory_limit_mb

    @property
    def cpu_limit(self):
        """Gets the cpu_limit of this ZoneAssignmentSpecification.  # noqa: E501

        The maximum amount of cpus that can be used by this cloud zone. Default is 0 (unlimited cpu).  # noqa: E501

        :return: The cpu_limit of this ZoneAssignmentSpecification.  # noqa: E501
        :rtype: int
        """
        return self._cpu_limit

    @cpu_limit.setter
    def cpu_limit(self, cpu_limit):
        """Sets the cpu_limit of this ZoneAssignmentSpecification.

        The maximum amount of cpus that can be used by this cloud zone. Default is 0 (unlimited cpu).  # noqa: E501

        :param cpu_limit: The cpu_limit of this ZoneAssignmentSpecification.  # noqa: E501
        :type: int
        """

        self._cpu_limit = cpu_limit

    @property
    def storage_limit_gb(self):
        """Gets the storage_limit_gb of this ZoneAssignmentSpecification.  # noqa: E501

        Defines an upper limit on storage that can be requested from a cloud zone which is part of this project. Default is 0 (unlimited storage). Please note that this feature is supported only for vSphere cloud zones. Not valid for other cloud zone types.  # noqa: E501

        :return: The storage_limit_gb of this ZoneAssignmentSpecification.  # noqa: E501
        :rtype: int
        """
        return self._storage_limit_gb

    @storage_limit_gb.setter
    def storage_limit_gb(self, storage_limit_gb):
        """Sets the storage_limit_gb of this ZoneAssignmentSpecification.

        Defines an upper limit on storage that can be requested from a cloud zone which is part of this project. Default is 0 (unlimited storage). Please note that this feature is supported only for vSphere cloud zones. Not valid for other cloud zone types.  # noqa: E501

        :param storage_limit_gb: The storage_limit_gb of this ZoneAssignmentSpecification.  # noqa: E501
        :type: int
        """

        self._storage_limit_gb = storage_limit_gb

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ZoneAssignmentSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ZoneAssignmentSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
